# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/aspects/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion 1.0.0.GA

Name:           jboss-security-aspects
Version:        1.0.0
Release:        2.4%{?dist}
Epoch:          0
Summary:        JBoss Security Aspects
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
Source0:        jboss-security-aspects-1.0.0.tar.gz
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-aspects/tags/jboss-security-aspects-1.0.0.GA/ jboss-security-aspects-1.0.0

Source1:        jboss-security-aspects-jpp-depmap.xml
Source2:        jboss-security-aspects-settings.xml
Source3:	%{name}-component-info.xml

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  dtdparser
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-maven-plugin

BuildRequires:  gnu-trove
BuildRequires:  jacc_1_1_api
BuildRequires:  jakarta-commons-codec
BuildRequires:  jboss-aop2
BuildRequires:	jboss-aspects-build
BuildRequires:  jboss-aspects-common
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-parent
BuildRequires:  jboss-security-spi
BuildRequires:  jbosssx2
BuildRequires:  qdox

Requires:  gnu-trove
Requires:  jacc_1_1_api
Requires:  jboss-aop2
Requires:  jboss-aspects-build
Requires:  jboss-aspects-common
Requires:  jboss-common-logging-spi
Requires:  jboss-microcontainer2
Requires:  jboss-security-spi
Requires:  jbosssx2

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss security aspects.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q 
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.aspects %{name} %{namedversion} JPP %{name}
install -m 644 target/%{name}-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-tests.jar
install -m 644 target/%{name}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
   -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
   -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar \
   -Dclassifier=javadoc

tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE3}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE3}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}.jar
        cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-javadoc.jar
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-sources.jar
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-tests.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-tests.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-2.4
- Rebuild for MEAD
- Add BR qdox

* Fri Nov 19 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-2.3
- Build with maven 2.2.1
- Add (B)R jboss-aspects-build to remove bundled pom.xml
- Change BR maven-release to maven-release-plugin
- Add BR jakarta-commons-codec, maven-deploy-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-2.2.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.0-2.2
- Rebuild

* Thu Apr 1 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.0-2.1.1
- Merge from RHEL4

* Wed Mar 3 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.0-2.1
- Change (B)R:  jacc_1_0_api to jacc_1_1_api
- Add BR: dtdparser

* Tue Nov 17 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-2
- Add repolib
- Add javadoc, sources and tests to main package and repolib
- Add component-info.xml

* Wed Jun 24 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1.jpp5
- first release

